#PBForms CREATED V1.51
'------------------------------------------------------------------------------
' The first line in this file is a PB/Forms metastatement.
' It should ALWAYS be the first line of the file. Other
' PB/Forms metastatements are placed at the beginning and
' end of "Named Blocks" of code that should be edited
' with PBForms only. Do not manually edit or delete these
' metastatements or PB/Forms will not be able to reread
' the file correctly.  See the PB/Forms documentation for
' more information.
' Named blocks begin like this:    #PBFORMS BEGIN ...
' Named blocks end like this:      #PBFORMS END ...
' Other PB/Forms metastatements such as:
'     #PBFORMS DECLARATIONS
' are used by PB/Forms to insert additional code.
' Feel free to make changes anywhere else in the file.
'------------------------------------------------------------------------------

#Compile Exe
#Dim All

'------------------------------------------------------------------------------
'   ** Includes **
'------------------------------------------------------------------------------
#PBForms BEGIN INCLUDES
#If Not %Def(%WINAPI)
    #Include "WIN32API.INC"
#EndIf
#Include "PBForms.INC"
#PBForms END INCLUDES
'------------------------------------------------------------------------------

'------------------------------------------------------------------------------
'   ** Constants **
'------------------------------------------------------------------------------
#PBForms BEGIN CONSTANTS
%IDD_DIALOG_EXTRACTSOURCE =  101
%IDC_LABEL_CS             = 1002
%IDC_LISTBOX_CS           = 1001
%IDC_TEXTBOX_CODE         = 1003
%IDC_LABEL_CODE           = 1004
%IDC_BUTTON_CONTINUE      = 1006
%IDC_BUTTON_CANCEL        = 1005
#PBForms END CONSTANTS
'------------------------------------------------------------------------------

#Resource "APP.PBR"

Global hInst    As Dword

%WM_TRAYICON    = %WM_USER + 2048
%WM_INITCODE    = %WM_USER + 2049    ' Custom Message to view code
%WM_VIEWLAST    = %WM_USER + 2050

%IDM_VIEWLASTCOPY = 2001
%IDM_EXIT         = 2002

Global FoundWithQuotes  As Long

'------------------------------------------------------------------------------
'   ** Declarations **
'------------------------------------------------------------------------------
Declare CallBack Function ShowDIALOG_EXTRACTSOURCEProc()
Declare Function ShowDIALOG_EXTRACTSOURCE(ByVal hParent As Dword) As Long
#PBForms DECLARATIONS
'------------------------------------------------------------------------------

Declare Sub      WriteToClipBoard(ByVal Buffer As String)
Declare Function GetHTMLData() As String
Declare Function CheckClipboardData(Buffer As String) As Long
Declare Function ExtractCodeSegment(Buffer As String, SegmentIndex As Long) As String

'------------------------------------------------------------------------------
'   ** Main Application Entry Point **
'------------------------------------------------------------------------------
Function WinMain(ByVal hInstance As Dword, ByVal  hPrevInst As Dword, ByVal lpszCmdLine As Asciiz Ptr, ByVal nCmdShow As Long) As Long

    hInst = hInstance

    ShowDIALOG_EXTRACTSOURCE %HWND_DESKTOP

End Function
'------------------------------------------------------------------------------

'------------------------------------------------------------------------------
'   ** CallBacks **
'------------------------------------------------------------------------------
CallBack Function ShowDIALOG_EXTRACTSOURCEProc()

    Local pt            As POINTAPI
    Local hPopup        As Dword
    Local lRet          As Long
    Local CBBuffer      As String
    Local x             As Long
    Local hWndLB        As Dword
    Local LBSel         As Long
    Local LBItemCount   As Long
    Local LBSelState    As Long

    Dim CSData()        As Static String

    Static CodeSegments As Long
    Static HTMLBuffer   As String
    Static hIcon        As Dword
    Static nfIconData   As NOTIFYICONDATA
    Static hCBChain     As Dword

    Select Case As Long CbMsg
        Case %WM_INITDIALOG
            hCBChain                    = SetClipboardViewer(CbHndl)
            hIcon                       = LoadIcon(hInst, "ICON")
            nfIconData.hwnd             = CbHndl
            nfIconData.uID              = hInst
            nfIconData.uFlags           = %NIF_ICON Or %NIF_MESSAGE Or %NIF_TIP
            nfIconData.uCallbackMessage = %WM_TRAYICON
            nfIconData.hIcon            = hIcon
            nfIconData.szTip            = "PB Forum - Extract Source"
            nfIconData.cbSize           = SizeOf(nfIconData)
            Shell_NotifyIcon %NIM_ADD, nfIconData

        Case %WM_TRAYICON
            Select Case Lo(Word, CbLParam)
                Case %WM_LBUTTONUP, %WM_RBUTTONUP
                    GetCursorPos pt
                    SetForegroundWindow CbHndl
                    hPopup = CreatePopupMenu()
                    InsertMenu hPopup, 1, IIf&(UBound(CSData) > 0, %MF_ENABLED, %MF_GRAYED) Or %MF_BYCOMMAND, %IDM_VIEWLASTCOPY, "View Last Copied Data"
                    InsertMenu hPopup, 2, %MF_SEPARATOR, 2, "-"
                    InsertMenu hPopup, 3, %MF_ENABLED Or %MF_BYCOMMAND, %IDM_EXIT, "Exit"
                    lRet = TrackPopupMenu(hPopup, %TPM_BOTTOMALIGN Or %TPM_RIGHTALIGN Or %TPM_RIGHTBUTTON, pt.x, pt.y, 0, CbHndl, ByVal %NULL)
                    DestroyMenu hPopup
            End Select

        Case %WM_DESTROY
            Shell_NotifyIcon %NIM_DELETE, nfIconData
            ChangeClipboardChain CbHndl, hCBChain

        Case %WM_SYSCOMMAND
            If (CbWParam And &HFFF0)=%SC_MINIMIZE Or (CbWParam And &HFFF0)=%SC_CLOSE Then
                Dialog Show State CbHndl, %SW_HIDE
                Function = 1
                Exit Function
            End If

        Case %WM_VIEWLAST
            CodeSegments = UBound(CSData)
            If CodeSegments = 0 Then
                Exit Function
            End If
            If GetForegroundWindow() <> CbHndl Then
                SetForegroundWindow CbHndl
            End If
            ListBox Reset CbHndl, %IDC_LISTBOX_CS
            For x = 1 To CodeSegments
                ListBox Add CbHndl, %IDC_LISTBOX_CS, "Segment "+Format$(x)
            Next
            ListBox Select CbHndl, %IDC_LISTBOX_CS, 1
            Control Set Focus CbHndl, %IDC_LISTBOX_CS
            Control Set Text CbHndl, %IDC_TEXTBOX_CODE, CSData(1)

        Case %WM_INITCODE
            If GetForegroundWindow() <> CbHndl Then
                SetForegroundWindow CbHndl
            End If
            ListBox Reset CbHndl, %IDC_LISTBOX_CS
            ReDim CSData(1 To CodeSegments) As Static String
            For x = 1 To CodeSegments
                CSData(x) = ExtractCodeSegment(HTMLBuffer, x)
                ListBox Add CbHndl, %IDC_LISTBOX_CS, "Segment "+Format$(x)
            Next
            ListBox Select CbHndl, %IDC_LISTBOX_CS, 1
            Control Set Focus CbHndl, %IDC_LISTBOX_CS
            Control Set Text CbHndl, %IDC_TEXTBOX_CODE, CSData(1)

        Case %WM_DRAWCLIPBOARD
            HTMLBuffer = GetHTMLData()
            CodeSegments = CheckClipboardData(HTMLBuffer)
            If CodeSegments > 1 Then
                Dialog Show State CbHndl, %SW_SHOW
                PostMessage CbHndl, %WM_INITCODE, 0, 0
            ElseIf CodeSegments = 1 Then
                CBBuffer = ExtractCodeSegment(HTMLBuffer, 1)
                ReDim CSData(1 To 1) As Static String
                CSData(1) = CBBuffer
                WriteToClipboard CBBuffer
            End If
            SendMessage hCBChain, CbMsg, CbWParam, CbLParam

        Case %WM_COMMAND
            Select Case As Long CbCtl
                Case %IDM_VIEWLASTCOPY
                    Dialog Show State CbHndl, %SW_SHOW
                    PostMessage CbHndl, %WM_VIEWLAST, 0, 0

                Case %IDM_EXIT
                    PostQuitMessage 0
                    Dialog End CbHndl

                Case %IDC_LISTBOX_CS
                    If CbCtlMsg = %LBN_SELCHANGE Then
                        hWndLB = GetDlgItem(CbHndl, CbCtl)
                        LBSel = SendMessage(hWndLB, %LB_GETCURSEL, 0, 0)
                        If LBSel <> %LB_ERR Then
                            Incr LBSel
                            Control Set Text CbHndl, %IDC_TEXTBOX_CODE, CSData(LBSel)
                        End If
                    End If

                Case %IDC_LABEL_CS

                Case %IDC_TEXTBOX_CODE

                Case %IDC_LABEL_CODE

                Case %IDCANCEL
                    PostMessage CbHndl, %WM_COMMAND, Mak(Long, %IDC_BUTTON_CANCEL, %BN_CLICKED), 0

                Case %IDC_BUTTON_CANCEL
                    If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then
                        Dialog Show State CbHndl, %SW_HIDE
                    End If

                Case %IDC_BUTTON_CONTINUE
                    If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then
                        hWndLB = GetDlgItem(CbHndl, %IDC_LISTBOX_CS)
                        LBItemCount = SendMessage(hWndLB, %LB_GETCOUNT, 0, 0)
                        If LBItemCount <> %LB_ERR Then
                            For x = 0 To LBItemCount - 1
                                LBSelState = SendMessage(hWndLB, %LB_GETSEL, 0, 0)
                                If LBSelState > 0 Then
                                    CBBuffer = CBBuffer + CSData(x + 1) + $CrLf + $CrLf
                                End If
                            Next
                            WriteToClipboard CBBuffer
                            PostMessage CbHndl, %WM_SYSCOMMAND, %SC_MINIMIZE, 0
                        Else
                            MsgBox "No Code Segment Selected.", %MB_ICONERROR Or %MB_TASKMODAL, "PB Forums - Extract Source Code from HTML"
                        End If
                    End If

            End Select
    End Select
End Function
'------------------------------------------------------------------------------

'------------------------------------------------------------------------------
'   ** Dialogs **
'------------------------------------------------------------------------------
Function ShowDIALOG_EXTRACTSOURCE(ByVal hParent As Dword) As Long
    Local lRslt  As Long

#PBForms BEGIN DIALOG %IDD_DIALOG_EXTRACTSOURCE->->
    Local hDlg   As Dword
    Local hFont1 As Dword

    Dialog New hParent, "PB Forums - Extract Source Code from HTML", 94, 70, _
        513, 308, %WS_POPUP Or %WS_BORDER Or %WS_DLGFRAME Or %WS_SYSMENU Or _
        %WS_MINIMIZEBOX Or %WS_CLIPSIBLINGS Or %WS_VISIBLE Or %DS_MODALFRAME _
        Or %DS_3DLOOK Or %DS_NOFAILCREATE Or %DS_SETFONT, _
        %WS_EX_CONTROLPARENT Or %WS_EX_LEFT Or %WS_EX_LTRREADING Or _
        %WS_EX_RIGHTSCROLLBAR, To hDlg
    Control Add ListBox, hDlg, %IDC_LISTBOX_CS, , 5, 15, 110, 290, %WS_CHILD _
        Or %WS_VISIBLE Or %WS_TABSTOP Or %WS_VSCROLL Or %LBS_EXTENDEDSEL Or _
        %LBS_NOTIFY, %WS_EX_CLIENTEDGE Or %WS_EX_LEFT Or %WS_EX_LTRREADING _
        Or %WS_EX_RIGHTSCROLLBAR
    Control Add Label,   hDlg, %IDC_LABEL_CS, "Select Code Segment To Copy:", _
        5, 5, 105, 10
    Control Add TextBox, hDlg, %IDC_TEXTBOX_CODE, "TextBox1", 120, 15, 390, _
        270, %WS_CHILD Or %WS_VISIBLE Or %WS_TABSTOP Or %WS_HSCROLL Or _
        %WS_VSCROLL Or %ES_LEFT Or %ES_MULTILINE Or %ES_AUTOHSCROLL Or _
        %ES_AUTOVSCROLL, %WS_EX_CLIENTEDGE Or %WS_EX_LEFT Or _
        %WS_EX_LTRREADING Or %WS_EX_RIGHTSCROLLBAR
    Control Add Label,   hDlg, %IDC_LABEL_CODE, "Code:", 120, 5, 100, 10
    Control Add Button,  hDlg, %IDC_BUTTON_CANCEL, "C&ancel", 460, 290, 50, _
        15
    Control Add Button,  hDlg, %IDC_BUTTON_CONTINUE, "&Continue", 405, 290, _
        50, 15

    hFont1 = PBFormsMakeFont("Courier New", 9, 400, %FALSE, %FALSE, %FALSE, _
        %ANSI_CHARSET)

    Control Send hDlg, %IDC_LISTBOX_CS, %WM_SETFONT, hFont1, 0
    Control Send hDlg, %IDC_TEXTBOX_CODE, %WM_SETFONT, hFont1, 0
#PBForms END DIALOG

    Dialog Show State hDlg, %SW_HIDE
    Dialog Show Modal hDlg, Call ShowDIALOG_EXTRACTSOURCEProc To lRslt

#PBForms BEGIN CLEANUP %IDD_DIALOG_EXTRACTSOURCE
    DeleteObject hFont1
#PBForms END CLEANUP

    Function = lRslt
End Function
'------------------------------------------------------------------------------
Function CheckClipboardData(Buffer As String) As Long

    Local lRet  As Long

    If Len(Buffer) <> 0 Then
        If InStr(UCase$(Buffer), "<PRE CLASS=""ALT2") <> 0 Then
            FoundWithQuotes = %TRUE
        Else
            FoundWithQuotes = %FALSE
        End If
    End If

    If Len(Buffer) <> 0 Then
        lRet = Tally(UCase$(Buffer), "<PRE CLASS=" + IIf$(FoundWithQuotes = %TRUE, $Dq, "") + "ALT2")
    End If

    Function = lRet

End Function
'------------------------------------------------------------------------------
Function GetHTMLData() As String

    Local CBFormat      As Long
    Local hBuffer       As Asciiz Ptr
    Local Buffer        As String
    Local lRet          As Long
    Local hMem          As Long

    Static HTMLFormat   As Long

    OpenClipboard 0
    If HTMLFormat = 0 Then
        HTMLFormat = RegisterClipboardFormat("HTML Format")
    End If

    Do
        CBFormat = EnumClipboardFormats(CBFormat)
        If CBFormat = 0 Then Exit Do
        If CBFormat = HTMLFormat Then
            hMem = GetClipboardData(HTMLFormat)
            hBuffer = GlobalLock(hMem)
            If hBuffer Then
                Buffer = @hBuffer
                GlobalUnlock hMem
                Exit Do
            End If
        End If
    Loop

    CloseClipboard

    Function = Buffer

End Function
'------------------------------------------------------------------------------
Sub WriteToClipBoard(ByVal Buffer As String)

    Local MemPointer    As Asciiz Ptr
    Local hMem          As Dword

    hMem = GlobalAlloc(%GHND, Len(Buffer) + 1)
    MemPointer = GlobalLock(hMem)
    @MemPointer = Buffer
    GlobalUnlock hMem
    OpenClipboard 0
    EmptyClipboard
    SetClipboardData %CF_TEXT, hMem
    CloseClipboard
    GlobalFree(hMem)

End Sub
'------------------------------------------------------------------------------
Function ExtractCodeSegment(Buffer As String, SegmentIndex As Long) As String

    Local tmpBuffer As String
    Local sRet      As String
    Local x1        As Long
    Local x2        As Long
    Local tmpIndex  As Long

    tmpBuffer = UCase$(Buffer)

    x1 = InStr(tmpBuffer, "<PRE CLASS=" + IIf$(FoundWithQuotes = %TRUE, $Dq, "") + "ALT2")
    tmpIndex = 1
    If SegmentIndex > 1 Then
        While tmpIndex < SegmentIndex And x1 > 0
            x2 = InStr(x1, tmpBuffer, ">")
            x1 = InStr(x2, tmpBuffer, "<PRE CLASS=" + IIf$(FoundWithQuotes = %TRUE, $Dq, "") + "ALT2")
            Incr tmpIndex
        Wend
    End If

    If x1 > 0 Then
        x2 = InStr(x1, tmpBuffer, ">")
        x1 = x2 + 1
        x2 = InStr(x1, tmpBuffer, "</PRE>")
        sRet = Mid$(Buffer, x1, x2 - x1)
        Replace "&gt;" With ">" In sRet
        Replace "&lt;" With "<" In sRet
        Replace "&quot;" With $Dq In sRet
        Replace "&amp;" With "&" In sRet
    End If

    Function = sRet

End Function
'------------------------------------------------------------------------------
